///////////////////////////////////////////////////////
//
// CvtBmp.cpp
//
// Simple skeleton implementation of a BMP
// converter. Note that this class is not directly
// referenced from anywhere else in the code.
//
///////////////////////////////////////////////////////

#include <stdio.h>
#include <vector>
#include "Store.h"
#include "Cvt.h"
#include "CvtProxy.h"

////////////////////////////////////////////////////////////
// Definition of class BmpFileConverter

class BmpFileConverter : public FileConverter
{
public:
    virtual void Import(const char *filename)
		{ printf("Importing %s with BMP Converter\n", filename); }
    virtual void Export(const char *filename)
		{ printf("Exporting %s with BMP Converter\n", filename); }

    // These are the criteria support functions
    static const char* GetExtension()
		{ return ".bmp"; }
    static bool IsCompressed()
		{ return false; }
};

////////////////////////////////////////////////////////////
// Declare an instance of the proxy to register the
// existence of BmpFileConverter with the Specialty Store.

static FileConverterProxy<BmpFileConverter> gBmpProxy;
