///////////////////////////////////////////////////////
//
// CvtGif.cpp
//
// Simple skeleton implementation of a GIF
// converter. Note that this class is not directly
// referenced from anywhere else in the code.
//
///////////////////////////////////////////////////////

#include <stdio.h>
#include <vector>
#include "Store.h"
#include "Cvt.h"
#include "CvtProxy.h"

////////////////////////////////////////////////////////////
// Definition of class GifFileConverter

class GifFileConverter : public FileConverter
{
public:
    virtual void Import(const char *filename)
		{ printf("Importing %s with GIF Converter\n", filename); }
    virtual void Export(const char *filename)
		{ printf("Exporting %s with GIF Converter\n", filename); }

    // These are the criteria support functions
    static const char* GetExtension()
		{ return ".gif"; }
    static bool IsCompressed()
		{ return true; }
};

////////////////////////////////////////////////////////////
// Declare an instance of the proxy to register the
// existence of GifFileConverter with the Specialty Store.

static FileConverterProxy<GifFileConverter> gGifProxy;
