///////////////////////////////////////////////////////
//
// CvtProxy.h
//
// Definition of class FileConverterProxyBase
//
///////////////////////////////////////////////////////

class FileConverterProxyBase
{
public:
    FileConverterProxyBase();
    virtual FileConverter* CreateObject() const = 0;

    // Expose criteria here
    virtual const char* GetExtension() const = 0;
    virtual bool IsCompressed() const = 0;
};

inline FileConverterProxyBase::FileConverterProxyBase()
{
	gConverterStore.Register(this);
}


//////////////////////////////////////////////
//
// template FileConverterProxy<>
//

template <class T>
class FileConverterProxy : public FileConverterProxyBase
{
    FileConverter* CreateObject() const
        { return new T; }

    // Member functions in T are static
    virtual const char* GetExtension() const
        { return T::GetExtension(); }
    virtual bool IsCompressed() const
        { return T::IsCompressed(); }
};
