///////////////////////////////////////////////////////
//
// CvtTiff.cpp
//
// Simple skeleton implementation of a TIFF
// converter. Note that this class is not directly
// referenced from anywhere else in the code.
//
///////////////////////////////////////////////////////

#include <stdio.h>
#include <vector>
#include "Store.h"
#include "Cvt.h"
#include "CvtProxy.h"

////////////////////////////////////////////////////////////
// Definition of class TiffFileConverter

class TiffFileConverter : public FileConverter
{
public:
    virtual void Import(const char *filename)
		{ printf("Importing %s with TIFF Converter\n", filename); }
    virtual void Export(const char *filename)
		{ printf("Exporting %s with TIFF Converter\n", filename); }

    // These are the criteria support functions
    static const char* GetExtension()
		{ return ".tif"; }
    static bool IsCompressed()
		{ return true; }
};

////////////////////////////////////////////////////////////
// Declare an instance of the proxy to register the
// existence of TiffFileConverter with the Specialty Store.

static FileConverterProxy<TiffFileConverter> gTiffProxy;
