// This source code is a small sub-set of the Objective Grid C++ Library
// from Stingray Software, Inc.

// For more information visit: http://www.stingsoft.com

//  Author:		    Stefan Hoenig
//  Created:		11/14/97
//

/////////////////////////////////////////////////////////////////////////////
// ddjmouse.h : interface of the CDDJIntelliMousePlugin class

#ifndef _DDJMOUSE_H_
#define _DDJMOUSE_H_

#ifndef _DDJPLGIN_H_
#include "ddjplgin.h"
#endif

#define WM_DDJ_IMOUSE_GETZOOM			(WM_USER+991)
#define WM_DDJ_IMOUSE_SETZOOM			(WM_USER+992)

class CDDJMouseWheelOriginWnd: public CWnd
{
	DECLARE_DYNAMIC(CDDJMouseWheelOriginWnd)
public:
	CDDJMouseWheelOriginWnd();
	BOOL CreateWnd(CWnd* pParent, UINT nID);

// Operations
public:
	static void DrawTransparentBitmap(CDC* pDC, CBitmap* pBitmap, int xStart,
		int yStart, COLORREF cTransparentColor);

// Attributes
public:
	CBitmap m_bmOrigin;
	CSize m_size;

	// Generated message map functions
protected:
	//{{AFX_MSG(CDDJMouseWheelOriginWnd)
	afx_msg void OnPaint();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

class CDDJIntelliMousePlugin: public CDDJPluginComponent
{
	DECLARE_DYNAMIC(CDDJIntelliMousePlugin)
public: 
	CDDJIntelliMousePlugin();

// Attributes
public:
	BOOL m_bMouseWheelDrag;
	DWORD m_dwMouseWheelTick;
	DWORD m_dwMouseWheelLastTick;
	int m_nMouseWheelNextTicks;
	int m_nMouseWheelLastDirection;
	int m_nMouseWheelTimer;
	CPoint m_ptMouseWheelOrg;
	BOOL m_bMouseWheelCanVertScroll;
	BOOL m_bMouseWheelCanHorzScroll;
	CDDJMouseWheelOriginWnd* m_pWndOrigin;
	UINT m_idcCursor; 

// Operations
public:
	void KillMouseWheel(CPoint point);
	void SetImouseCursor(UINT idcCursor);
	BOOL ShowImouseCursor(UINT idcPrimary);

// Overrides
	virtual int OnIMouseGetZoom();
	virtual void OnIMouseSetZoom(int nZoom);
	virtual void OnIMouseVScroll(UINT nSBCode, UINT nPos);
	virtual void OnIMouseHScroll(UINT nSBCode, UINT nPos);

// Implementation
public:
	virtual ~CDDJIntelliMousePlugin();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CDDJIntelliMousePlugin)
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnMButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnCancelMode();
	//}}AFX_MSG
	afx_msg LRESULT OnSettingChange(WPARAM, LPARAM);
	DECLARE_MESSAGE_MAP()
};


#endif //_DDJMOUSE_H_

