// This source code is a small sub-set of the Objective Grid C++ Library
// from Stingray Software, Inc.

// For more information visit: http://www.stingsoft.com

//  Author:		    Stefan Hoenig
//  Created:		11/14/97
//

// myView.cpp : implementation of the CMyView class
//

#include "stdafx.h"
#include "autoscrl.h"

#include "MyDoc.h"
#include "myView.h"
#include "ddjmouse.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyView

IMPLEMENT_DYNCREATE(CMyView, CScrollView)

BEGIN_MESSAGE_MAP(CMyView, CScrollView)
	//{{AFX_MSG_MAP(CMyView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CScrollView::OnFilePrintPreview)
	ON_MESSAGE(WM_DDJ_IMOUSE_GETZOOM, OnImouseGetZoom)
	ON_MESSAGE(WM_DDJ_IMOUSE_SETZOOM, OnImouseSetZoom)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyView construction/destruction

CMyView::CMyView()
{
	m_pPlugin = NULL;
	m_nZoom = 200;
}

CMyView::~CMyView()
{
	delete m_pPlugin;
}

BOOL CMyView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CScrollView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMyView drawing

void CMyView::OnDraw(CDC* pDC)
{
	CMyDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CSize sizeTotal = GetTotalSize();

	CRect rect;
	GetClientRect(rect);
	rect += GetScrollPosition();

	int dx = 125;
	int dy = 60;
	int x1 = rect.left - (rect.left % dx);
	int y1 = rect.top - (rect.top % dy);
	int x2 = rect.right - (rect.right % dx) + dx;
	int y2 = rect.bottom - (rect.bottom % dy) + dy;

	for (int x = x1; x < x2; x += dx)
	{
		for (int y = y1; y < y2; y += dy)
		{
			CRect rect(x, y, x+100, y+50);
			pDC->SetBkColor(RGB(0, 0, 255));
			pDC->SetTextColor(RGB(255, 255, 255));

			CString s;
			s.Format("%05d/\n%05d", x, y);
			pDC->DrawText(s, rect, DT_WORDBREAK);
		}
	}
}

void CMyView::OnInitialUpdate()
{
	m_pPlugin = new CDDJIntelliMousePlugin;
	m_pPlugin->PlugIn(this);

	CScrollView::OnInitialUpdate();
	CSize sizeTotal;

	sizeTotal.cx = sizeTotal.cy = 15000;
	SetScrollSizes(MM_TEXT, sizeTotal);
}

/////////////////////////////////////////////////////////////////////////////
// CMyView printing

BOOL CMyView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CMyView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CMyView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CMyView diagnostics

#ifdef _DEBUG
void CMyView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CMyView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CMyDoc* CMyView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMyDoc)));
	return (CMyDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMyView message handlers

LRESULT CMyView::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	if (m_pPlugin)
   	{
		LRESULT lResult;
		m_pPlugin->HandleMessage(message, wParam, lParam, &lResult);

   		if (m_pPlugin->m_bExitMesssage)
			return lResult;
	}
	return CScrollView::WindowProc(message, wParam, lParam);
}

LRESULT CMyView::OnImouseGetZoom(WPARAM /*wParam*/, LPARAM /*lParam*/)
{
	return m_nZoom;
}

LRESULT CMyView::OnImouseSetZoom(WPARAM wParam, LPARAM /*lParam*/)
{
	// This is just to show you that the intelli-mouse plugin
	// sends you a zoom message. Zooming must be implemented
	// in your view.
	TRACE("Zoom to %d\n", wParam);

	m_nZoom = (int) wParam;

	return 0;
}
