// ------------------------------------------------------------
// Explicit channel Locking and Unlocking functionality
//
// Mauricio De Simone
// mdesimon@interlog.com
//
// Copyright (C) 1998  Mauricio De Simone
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation version 2.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------

//
// Intermidiate locked channel
//

class LockedChannel 
{
public:
  LockedChannel(Channel& c) :
    _channel(c) 
  {
    _channel.send_mutex()->lock();
  }

  ~LockedChannel() 
  {
    _channel.send_mutex()->unlock();
  }

  Channel& channel() {
    return _channel;
  }

private:
  Channel& _channel;
};



