// ------------------------------------------------------------
// Explicit channel Locking and Unlocking functionality
//
// Mauricio De Simone
// mdesimon@interlog.com
//
// Copyright (C) 1998  Mauricio De Simone
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation version 2.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------

//
// Operator machinery to lock and unlock explicitly
//

LockedChannel&
operator << (Channel& c, ChannelLock& /*l*/)
{
  LockedChannel* h = new LockedChannel(c);
  return *h;
};

LockedChannel&
operator << (LockedChannel& lc, Streamable& data)
{
  data.pickle(lc.channel());
  return lc;
};

void
operator << (LockedChannel& lc, ChannelUnlock& /*u*/)
{
  delete &lc; 
};
