// ------------------------------------------------------------
// MSG
// MT-Safe Templated functions
// to stream messages to stdout
//
// Mauricio De Simone
// mdesimon@interlog.com
//
// Copyright (C) 1998  Mauricio De Simone
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation version 2.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------

template <class T0>
void MSG(const T0& arg0)
{
  Synchronize _with(IO_Mutex);
  cout << arg0 << endl;
}

template <class T0, class T1>
void MSG(const T0& arg0, const T1& arg1)
{
  Synchronize _with(IO_Mutex);
  cout << arg0 << " : " << arg1 << endl;
}

template <class T0, class T1, class T2>
void MSG(const T0& arg0, const T1& arg1, const T2& arg2)
{
  Synchronize _with(IO_Mutex);
  cout << arg0 << " : " << arg1
       << " : " << arg2 << endl;
}

template <class T0, class T1, class T2, class T3>
void MSG(const T0& arg0, const T1& arg1, const T2& arg2,
         const T3& arg3)
{
  Synchronize _with(IO_Mutex);
  cout << arg0 << " : " << arg1
       << " : " << arg2 << " : " << arg3 << endl;
}

template <class T0, class T1, class T2, class T3, class T4>
void MSG(const T0& arg0, const T1& arg1, const T2& arg2,
         const T3& arg3, const T4& arg4)
{
  Synchronize _with(IO_Mutex);
  cout << arg0 << " : " << arg1
       << " : " << arg2 << " : " << arg3 << " : "
       << arg4 << endl;
}

