// This source code is a small sub-set of the Objective Grid C++ Library
// from Stingray Software, Inc.

// For more information visit: http://www.stingsoft.com

//  Author:		    Stefan Hoenig
//  Created:		11/14/97
//

// AutoPlug.cpp : implementation file
//

#include "stdafx.h"
#include "autoscrl.h"
#include "AutoPlug.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const int nScrollTimer = 991;

/////////////////////////////////////////////////////////////////////////////
// CAutoScrollPlugin

CAutoScrollPlugin::CAutoScrollPlugin()
{
	m_bIsAutoScrolling = FALSE;
	m_nTimer = 0;
}

CAutoScrollPlugin::~CAutoScrollPlugin()
{
}


BEGIN_MESSAGE_MAP(CAutoScrollPlugin, CDDJPluginComponent)
	//{{AFX_MSG_MAP(CAutoScrollPlugin)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_TIMER()
	ON_WM_KEYDOWN()
	ON_WM_CANCELMODE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CAutoScrollPlugin message handlers

void CAutoScrollPlugin::OnLButtonDown(UINT nFlags, CPoint point) 
{
	m_ptMouseDown = point;
	ClientToScreen(&m_ptMouseDown);

	m_bIsAutoScrolling = TRUE;
	
	SetCapture();

	m_nTimer = SetTimer(nScrollTimer, 10, NULL);

	m_bExitMesssage = TRUE;
}

void CAutoScrollPlugin::OnLButtonUp(UINT nFlags, CPoint point) 
{
	if (m_bIsAutoScrolling)
		AbortScrolling();

	CDDJPluginComponent::OnLButtonUp(nFlags, point);
}

void CAutoScrollPlugin::OnTimer(UINT nIDEvent) 
{
	CPoint pt;
	GetCursorPos(&pt);

	UINT nSBCode = SB_LINEUP;
	if (pt.y > m_ptMouseDown.y)
		nSBCode = SB_LINEDOWN;
		
	SendMessage(WM_VSCROLL, MAKEWPARAM(nSBCode, 0), NULL);
	
	CDDJPluginComponent::OnTimer(nIDEvent);
}

void CAutoScrollPlugin::AbortScrolling() 
{
	if (m_bIsAutoScrolling)
	{
		m_bIsAutoScrolling = FALSE;
		ReleaseCapture();
		KillTimer(m_nTimer);
	}
}

void CAutoScrollPlugin::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	if (nChar == VK_ESCAPE)
		AbortScrolling();
	
	CDDJPluginComponent::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CAutoScrollPlugin::OnCancelMode() 
{
	AbortScrolling();
}
