// This source code is a small sub-set of the Objective Grid C++ Library
// from Stingray Software, Inc.

// For more information visit: http://www.stingsoft.com

//  Author:		    Stefan Hoenig
//  Created:		11/14/97
//

// ddjplgin.cpp : implementation of the CDDJPluginComponent class
//

#include "stdafx.h"
#include "resource.h"

#include "ddjplgin.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNAMIC(CDDJPluginComponent, CWnd);

CDDJPluginComponent::CDDJPluginComponent()
{
	m_bSkipOtherPlugins = FALSE;
	m_bExitMesssage = FALSE;
}

CDDJPluginComponent::~CDDJPluginComponent()
{
	// make sure Detach won't get called
	m_hWnd = NULL;
}

BEGIN_MESSAGE_MAP(CDDJPluginComponent, CWnd)
	//{{AFX_MSG_MAP(CDDJPluginComponent)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CDDJPluginComponent::PlugIn(CWnd* pParentWnd)
{
	m_hWnd = pParentWnd->GetSafeHwnd();

	return TRUE;
}

BOOL CDDJPluginComponent::HandleMessage(UINT message, WPARAM wParam, LPARAM lParam, LRESULT* pResult)
{
	m_bSkipOtherPlugins = FALSE;
	m_bExitMesssage = FALSE;

#if _MFC_VER >= 0x0400
	return CWnd::OnWndMsg(message, wParam, lParam, pResult);
#else
	*pResult = CWnd::WindowProc(message, wParam, lParam);
	return TRUE;
#endif
}

LRESULT CDDJPluginComponent::DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam)
{
	// do nothing - this makes sure that calls to Default() 
	// will have no effect (and thus make sure that the same
	// message is not process twice).

	// Unused:
	message, wParam, lParam;

	return 0;
}

#ifdef _DEBUG
void CDDJPluginComponent::AssertValid() const
{
	if (m_hWnd == NULL)
		return;     // null (unattached) windows are valid

	// should be a normal window
	ASSERT(::IsWindow(m_hWnd));

	// Regular CWnd's check the permanent or temporary handle map
	// and compare the pointer to this.
	// This will fail for a CDDJPluginComponent because several
	// Plugin objects share the same HWND. Therefore we must not
	// call CWnd::AsssertValid.
}

void CDDJPluginComponent::Dump(CDumpContext& dc) const
{
	dc << "PluginComponent";

	// It is safe to call CWnd::Dump
	CWnd::Dump(dc);
}

#endif


