/*---------------------------------------------------------------------------
         Copyright 1997    On Target Software    All Rights Reserved

  Dave Pomerantz, Nov 1997.  Updates available at http://www.targetsoft.com
-----------------------------------------------------------------------------
BtnUnits.h        Button showing temperature units, F for Fahrenheit or
                  C for Celsius.  When the user presses the button, 
                  the units are toggled and a notifier is sent out. 
---------------------------------------------------------------------------*/
#ifndef BTNUNITS_H
#define BTNUNITS_H
#include "thermSubscriber.h"

//---------------------------------------------------------------------------
class CBtnUnits : public CButton, CThermSubscriber
//---------------------------------------------------------------------------
{
public:
   // Construction and Destruction
	CBtnUnits();
	virtual ~CBtnUnits();

   // Initialization
   HRESULT Init(CWnd *pParent, UINT nID);

   // Size and position
   void SetRect(CRect &rect);
   static void GetDesiredSize(int &width, int &height);

   // Notifiers
   virtual void OnRequestNotifier(CRequestNotifier *pNotifier);

   // implementation
protected: 
   THERM_UNITS    m_units;
   CRect          m_rectWindow;  // client rect in parent's coordinates
   CFont          m_font;
   
protected:     // MFC generated functions, message maps, etc.
   //{{AFX_VIRTUAL(CBtnUnits)
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CBtnUnits)
	afx_msg void OnClicked();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};
//{{AFX_INSERT_LOCATION}}

#endif // BTNUNITS_H
