/*---------------------------------------------------------------------------
         Copyright 1997    On Target Software    All Rights Reserved

  Dave Pomerantz, Nov 1997.  Updates available at http://www.targetsoft.com
-----------------------------------------------------------------------------
TextDegrees.h     Static text window showing current temperature 
                  in degrees Celsius or Fahrenheit, depending on
                  the current Units setting.
---------------------------------------------------------------------------*/
#ifndef TEXTDEGREES_H
#define TEXTDEGREES_H
#include "thermSubscriber.h"

//---------------------------------------------------------------------------
class CTextDegrees : public CWnd, CThermSubscriber
//---------------------------------------------------------------------------
{
public:
   // Construction and Destruction
	CTextDegrees(void);
	virtual ~CTextDegrees(void);

   // Initialization
   HRESULT Init(CWnd *pParent, UINT nID);

   // Size and position
   void SetRect(CRect &rect);
   static void GetDesiredSize(int &width, int &height);

   // Notifiers
   virtual void OnTemperatureNotifier(CTemperatureNotifier *pNotifier);
   virtual void OnUnitsNotifier(CUnitsNotifier *pNotifier);

   // implementation
protected:  
   float       m_fCurrTemp;   // current temperature
   THERM_UNITS m_units;       // celsius or fahrenheit
   CRect       m_rectWindow;  // client rect in parent's coordinates

   CFont       m_font;
   CBrush      m_brushLtGray;

   void DrawCurrentTemperature(void);

protected:     // MFC generated functions, message maps, etc.
	//{{AFX_VIRTUAL(CTextDegrees)
	//}}AFX_VIRTUAL
	//{{AFX_MSG(CTextDegrees)
	afx_msg void OnPaint();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};
//{{AFX_INSERT_LOCATION}}

#endif // TEXTDEGREES_H
