/*---------------------------------------------------------------------------
         Copyright 1997    On Target Software    All Rights Reserved

  Dave Pomerantz, Nov 1997.  Updates available at http://www.targetsoft.com
-----------------------------------------------------------------------------
TextSetPoint.h    Static text window showing current setpoint 
                  in degrees Celsius or Fahrenheit, depending on
                  the current Units setting.
---------------------------------------------------------------------------*/
#ifndef TEXTSETPOINT_H
#define TEXTSETPOINT_H
#include "thermSubscriber.h"

//---------------------------------------------------------------------------
class CTextSetPoint : public CWnd, CThermSubscriber
//---------------------------------------------------------------------------
{
public:
   // Construction and Destruction
	CTextSetPoint(void);
	virtual ~CTextSetPoint(void);

   // Initialization
   HRESULT Init(CWnd *pParent, UINT nID);

   // Size and position
   void SetRect(CRect &rect);
   static void GetDesiredSize(int &width, int &height);

   // Notifiers
   virtual void OnSetPointNotifier(CSetPointNotifier *pNotifier);
   virtual void OnUnitsNotifier(CUnitsNotifier *pNotifier);

   // implementation
protected:  
   float       m_fCurrSetPoint; // current set point in Celsius
   THERM_UNITS m_units;         // celsius or fahrenheit
   CRect       m_rectWindow;    // client rect in parent's coordinates

   CFont       m_font;
   CBrush      m_brushLtGray;

   void DrawCurrentSetPoint(void);

protected:     // MFC generated functions, message maps, etc.
	//{{AFX_VIRTUAL(CTextSetPoint)
	//}}AFX_VIRTUAL
	//{{AFX_MSG(CTextSetPoint)
	afx_msg void OnPaint();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};
//{{AFX_INSERT_LOCATION}}

#endif // TEXTSETPOINT_H
