/*---------------------------------------------------------------------------
         Copyright 1997    On Target Software    All Rights Reserved

  Dave Pomerantz, Nov 1997.  Updates available at http://www.targetsoft.com
-----------------------------------------------------------------------------
slider.h  CSetPointSlider class definition

This overrides the Windows common slider control to move the setpoint
up and down.
---------------------------------------------------------------------------*/
#ifndef SLIDER_H
#define SLIDER_H
#include "thermSubscriber.h"

class CTempScale;

//---------------------------------------------------------------------------
class CSetPointSlider : public CSliderCtrl, CThermSubscriber
//---------------------------------------------------------------------------
{
public:
   // Construction and Assignment
   CSetPointSlider(void);
   virtual ~CSetPointSlider(void);

   // Initialization
   HRESULT Init(CWnd *pParent, UINT nID);

   // Size and position
   void SetRect(CRect &rect);
   static void GetDesiredSize(int &width, int &height);
   void SetTemperatureRange(void);

   // Notifiers
   virtual void OnUnitsNotifier(CUnitsNotifier *pNotifier);
   virtual void OnRequestNotifier(CRequestNotifier *pNotifier);
protected:
   float GetNewSetPoint(void);

protected:
   CRect       m_rectWindow;  // client rect in parent's coordinates
   THERM_UNITS m_units;       // fahrenheit or celsius
   bool        m_bButtonDown; // true if mouse button is down
   float       m_fSetPoint;   // current set point
   float       m_fHiTemp;     // upper and lower bounds
   float       m_fLoTemp;     //   of the temperature range

   CTempScale *m_pScale;      // temperature scale object

protected:     // MFC generated functions, message maps, etc.
	//{{AFX_VIRTUAL(CSetPointSlider)
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CSetPointSlider)
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};
//{{AFX_INSERT_LOCATION}}

#endif // SLIDER_H
