/*---------------------------------------------------------------------------
         Copyright 1997    On Target Software    All Rights Reserved

  Dave Pomerantz, Nov 1997.  Updates available at http://www.targetsoft.com
-----------------------------------------------------------------------------
temperature.h   CTemperature class definition

This class runs in a separate thread, simulating a real-time temperature 
sensor that sends notifiers when the temperature changes.  It also responds
to the setpoint notifier as if the temperature were stabilizing around a
given setpoint.
---------------------------------------------------------------------------*/
#ifndef TEMPERATURE_H
#define TEMPERATURE_H
#include "thermSubscriber.h"

//---------------------------------------------------------------------------
class CTemperature : public CThermSubscriber
//---------------------------------------------------------------------------
{
public:
   // Construction and Assignment
   CTemperature(void);
   virtual ~CTemperature(void);

   void PollSensor(DWORD dwTime);

   // Notifier handlers
   virtual void OnRequestNotifier(CRequestNotifier *pNotifier);
   virtual void OnSetPointNotifier(CSetPointNotifier *pNotifier);

protected:
   float             m_fTemperature;   // always in centigrade
   float             m_fSetPoint;
   CRITICAL_SECTION  m_csTemperature;  // protects temperature
   CRITICAL_SECTION  m_csSetPoint;     // protects setpoint
};

#endif  TEMPERATURE_H

