/*---------------------------------------------------------------------------
         Copyright 1997    On Target Software    All Rights Reserved

  Dave Pomerantz, Nov 1997.  Updates available at http://www.targetsoft.com
-----------------------------------------------------------------------------
thermSubscriber.h   Subscriber subclass for the thermometer control
---------------------------------------------------------------------------*/
#ifndef THERM_SUBSCRIBER_H
#define THERM_SUBSCRIBER_H

#include "subscriber.h"

class CNotifier;
class CRequestNotifier;
class CTemperatureNotifier;
class CUnitsNotifier;
class CSetPointNotifier;

//---------------------------------------------------------------------------
class CThermSubscriber : public CSubscriber
//---------------------------------------------------------------------------
{
public:
   CThermSubscriber(SUBSCRIBER_PRIORITY nPriority = PRIORITY_NORMAL);
   CThermSubscriber(const CThermSubscriber &src);
   virtual ~CThermSubscriber(void);
   CThermSubscriber &operator=(const CThermSubscriber &src);

   virtual void OnRequestNotifier(CRequestNotifier *pNotifier);
   virtual void OnTemperatureNotifier(CTemperatureNotifier *pNotifier);
   virtual void OnUnitsNotifier(CUnitsNotifier *pNotifier);
   virtual void OnSetPointNotifier(CSetPointNotifier *pNotifier);
};

/************************
 *** INLINE FUNCTIONS ***
 ***********************/

/*---------------------------------------------------------------------------
default contructor     
---------------------------------------------------------------------------*/
inline CThermSubscriber::CThermSubscriber(SUBSCRIBER_PRIORITY nPriority)
                        :CSubscriber(nPriority)
{
}
/*---------------------------------------------------------------------------
copy constructor
---------------------------------------------------------------------------*/
inline CThermSubscriber::CThermSubscriber(const CThermSubscriber &src)
                        :CSubscriber(src)
{
   *this = src;
}
/*---------------------------------------------------------------------------
destructor     
---------------------------------------------------------------------------*/
inline CThermSubscriber::~CThermSubscriber(void)
{
}
/*---------------------------------------------------------------------------
assignment operator
---------------------------------------------------------------------------*/
inline CThermSubscriber &CThermSubscriber::operator=(const CThermSubscriber &src)
{
   CSubscriber::operator=(src);
   return *this;
}
/*---------------------------------------------------------------------------
OnRequestNotifier   
---------------------------------------------------------------------------*/
inline void CThermSubscriber::OnRequestNotifier(CRequestNotifier *)
{
}
/*---------------------------------------------------------------------------
OnTemperatureNotifier   
---------------------------------------------------------------------------*/
inline void CThermSubscriber::OnTemperatureNotifier(CTemperatureNotifier *)
{
}
/*---------------------------------------------------------------------------
OnUnitsNotifier   
---------------------------------------------------------------------------*/
inline void CThermSubscriber::OnUnitsNotifier(CUnitsNotifier *)
{
}
/*---------------------------------------------------------------------------
OnSetPointNotifier   
---------------------------------------------------------------------------*/
inline void CThermSubscriber::OnSetPointNotifier(CSetPointNotifier *)
{
}


#endif // THERM_SUBSCRIBER_H